Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2528)
@@ -2,22 +2,19 @@
    !!======================================================================
    !!                       ***  MODULE  sbcice_lim_2  ***
-   !! Surface module :  update surface ocean boundary condition over ice
-   !!                   covered area using LIM sea-ice model
-   !! Sea-Ice model  :  LIM 2.0 Sea ice model time-stepping
+   !! Surface module :  update surface ocean boundary condition over ice covered area using LIM sea-ice model
+   !! Sea-Ice model  :  LIM-2 Sea ice model time-stepping
    !!======================================================================
    !! History :  1.0   !  06-2006  (G. Madec)  from icestp_2.F90
    !!            3.0   !  08-2008  (S. Masson, E. .... ) coupled interface
+   !!            3.3   !  05-2009  (G.Garric) addition of the lim2_evp case
    !!----------------------------------------------------------------------
 #if defined key_lim2
    !!----------------------------------------------------------------------
-   !!   'key_lim2' :                                  LIM 2.0 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   sbc_ice_lim_2  : sea-ice model time-stepping and
-   !!                    update ocean sbc over ice-covered area
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE c1d             ! 1d configuration
-   USE dom_oce         ! ocean space and time domain
-   USE lib_mpp
+   !!   'key_lim2' :                                    LIM-2 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   sbc_ice_lim_2   : sea-ice model time-stepping and update ocean sbc over ice-covered area
+   !!----------------------------------------------------------------------
+   USE oce              ! ocean dynamics and tracers
+   USE dom_oce          ! ocean space and time domain
    USE ice_2
    USE par_ice_2
@@ -25,26 +22,29 @@
    USE dom_ice_2
 
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice   fields
-   USE sbcblk_core     ! Surface boundary condition: CORE bulk
-   USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
-   USE sbccpl          ! Surface boundary condition: coupled interface
+   USE sbc_oce          ! Surface boundary condition: ocean fields
+   USE sbc_ice          ! Surface boundary condition: ice   fields
+   USE sbcblk_core      ! Surface boundary condition: CORE bulk
+   USE sbcblk_clio      ! Surface boundary condition: CLIO bulk
+   USE sbccpl           ! Surface boundary condition: coupled interface
    USE albedo
 
-   USE phycst          ! Define parameters for the routines
-   USE eosbn2          ! equation of state
+   USE phycst           ! Define parameters for the routines
+   USE eosbn2           ! equation of state
    USE limdyn_2
    USE limtrp_2
    USE limdmp_2
    USE limthd_2
-   USE limsbc_2        ! sea surface boundary condition
+   USE limsbc_2         ! sea surface boundary condition
    USE limdia_2
    USE limwri_2
    USE limrst_2
 
-   USE lbclnk
-   USE iom             ! I/O manager library
-   USE in_out_manager  ! I/O manager
-   USE prtctl          ! Print control
+   USE c1d              ! 1D vertical configuration
+
+   USE lbclnk           ! lateral boundary condition - MPP link
+   USE lib_mpp          ! MPP library
+   USE iom              ! I/O manager library
+   USE in_out_manager   ! I/O manager
+   USE prtctl           ! Print control
 
    IMPLICIT NONE
@@ -52,6 +52,4 @@
 
    PUBLIC sbc_ice_lim_2 ! routine called by sbcmod.F90
-   
-   CHARACTER(len=1) ::   cl_grid = 'B'     ! type of grid used in ice dynamics
 
    !! * Substitutions
@@ -59,9 +57,8 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/SBC  3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -99,21 +96,30 @@
          IF(lwp) WRITE(numout,*) 'sbc_ice_lim_2 : update ocean surface boudary condition' 
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   via Louvain la Neuve Ice Model (LIM) time stepping'
-
+         !
          CALL ice_init_2
-
       ENDIF
 
-      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
-         !
+      !                                        !----------------------!
+      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN     !  Ice time-step only  !
+         !                                     !----------------------!
+         !  Bulk Formulea !
+         !----------------!
          ! ... mean surface ocean current at ice dynamics point
-         !     B-grid dynamics :  I-point 
-         DO jj = 2, jpj
-            DO ji = 2, jpi   ! B grid : no vector opt.
-               u_oce(ji,jj) = 0.5 * ( ssu_m(ji-1,jj  ) + ssu_m(ji-1,jj-1) ) * tmu(ji,jj)
-               v_oce(ji,jj) = 0.5 * ( ssv_m(ji  ,jj-1) + ssv_m(ji-1,jj-1) ) * tmu(ji,jj)
+         SELECT CASE( cp_ice_msh )
+         CASE( 'I' )                  !== B-grid ice dynamics :   I-point (i.e. F-point with sea-ice indexation)
+            DO jj = 2, jpj
+               DO ji = 2, jpi   ! NO vector opt. possible
+                  u_oce(ji,jj) = 0.5_wp * ( ssu_m(ji-1,jj  ) + ssu_m(ji-1,jj-1) ) * tmu(ji,jj)
+                  v_oce(ji,jj) = 0.5_wp * ( ssv_m(ji  ,jj-1) + ssv_m(ji-1,jj-1) ) * tmu(ji,jj)
+               END DO
             END DO
-         END DO
-         CALL lbc_lnk( u_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
-         CALL lbc_lnk( v_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            CALL lbc_lnk( u_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            CALL lbc_lnk( v_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+            !
+         CASE( 'C' )                  !== C-grid ice dynamics :   U & V-points (same as ocean)
+            u_oce(:,:) = ssu_m(:,:)                     ! mean surface ocean current at ice velocity point
+            v_oce(:,:) = ssv_m(:,:)
+            !
+         END SELECT
 
          ! ... masked sea surface freezing temperature [Kelvin] (set to rt0 over land)
@@ -144,5 +150,5 @@
                &                      qla_ice    , dqns_ice   , dqla_ice   ,            &
                &                      tprecip    , sprecip    ,                         &
-               &                      fr1_i0     , fr2_i0     , cl_grid    , jpl  )
+               &                      fr1_i0     , fr2_i0     , cp_ice_msh , jpl  )
 
          CASE( 4 )           ! CORE bulk formulation
@@ -151,5 +157,5 @@
                &                      qla_ice    , dqns_ice   , dqla_ice   ,            &
                &                      tprecip    , sprecip    ,                         &
-               &                      fr1_i0     , fr2_i0     , cl_grid    , jpl  )
+               &                      fr1_i0     , fr2_i0     , cp_ice_msh , jpl  )
          CASE( 5 )           ! Coupled formulation : atmosphere-ice stress only (fluxes provided after ice dynamics)
             CALL sbc_cpl_ice_tau( utau_ice , vtau_ice )
@@ -172,29 +178,39 @@
          !  Ice model step  !
          ! ---------------- !
-
-                                        CALL lim_rst_opn_2  ( kt )      ! Open Ice restart file
-         IF( .NOT. lk_c1d ) THEN                                        ! Ice dynamics & transport (not in 1D case)
-                                        CALL lim_dyn_2      ( kt )           ! Ice dynamics    ( rheology/dynamics )
-                                        CALL lim_trp_2      ( kt )           ! Ice transport   ( Advection/diffusion )
-            IF( ln_limdmp )             CALL lim_dmp_2      ( kt )           ! Ice damping 
-         ENDIF
+         numit = numit + nn_fsbc                           ! Ice model time step
+
+                           CALL lim_rst_opn_2  ( kt )  ! Open Ice restart file
+         IF( .NOT. lk_c1d ) THEN                       ! Ice dynamics & transport (except in 1D case)
+                           CALL lim_dyn_2      ( kt )      ! Ice dynamics    ( rheology/dynamics )
+                           CALL lim_trp_2      ( kt )      ! Ice transport   ( Advection/diffusion )
+           IF( ln_limdmp ) CALL lim_dmp_2      ( kt )      ! Ice damping 
+         END IF
 #if defined key_coupled
-         IF( ksbc == 5    )             CALL sbc_cpl_ice_flx( reshape( frld, (/jpi,jpj,1/) ),        &
-      &                                                       qns_tot, qns_ice, qsr_tot , qsr_ice,   &
-      &                                                       emp_tot, emp_ice, dqns_ice, sprecip,   &
+         !                                             ! Ice surface fluxes in coupled mode 
+         IF( ksbc == 5 )   CALL sbc_cpl_ice_flx( reshape( frld, (/jpi,jpj,1/) ),                 &
+      &                                                   qns_tot, qns_ice, qsr_tot , qsr_ice,   &
+      &                                                   emp_tot, emp_ice, dqns_ice, sprecip,   &
       !                                      optional arguments, used only in 'mixed oce-ice' case
-      &                                                       palbi = zalb_ice_cs, psst = sst_m, pist = sist )
+      &                                                   palbi = zalb_ice_cs, psst = sst_m, pist = sist )
 #endif
-                                        CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
-                                        CALL lim_sbc_2      ( kt )      ! Ice/Ocean Mass & Heat fluxes 
+                           CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
+                           CALL lim_sbc_flx_2  ( kt )      ! update surface ocean mass, heat & salt fluxes 
 
          IF( ( MOD( kt+nn_fsbc-1, ninfo ) == 0 .OR. ntmoy == 1 ) .AND. .NOT. lk_mpp )   &
-            &                           CALL lim_dia_2      ( kt )      ! Ice Diagnostics
+            &              CALL lim_dia_2      ( kt )      ! Ice Diagnostics
 # if ! defined key_iomput
-                                        CALL lim_wri_2      ( kt )      ! Ice outputs
+                           CALL lim_wri_2      ( kt )      ! Ice outputs
 # endif
-         IF( lrst_ice )                 CALL lim_rst_write_2( kt )      ! Ice restart file
+         IF( lrst_ice  )   CALL lim_rst_write_2( kt )      ! Ice restart file
          !
-      ENDIF
+      ENDIF                                    ! End sea-ice time step only
+      !
+      !                                        !--------------------------!
+      !                                        !  at all ocean time step  !
+      !                                        !--------------------------!
+      !                                               
+      !                                              ! Update surface ocean stresses (only in ice-dynamic case)
+      !                                                   ! otherwise the atm.-ocean stresses are used everywhere
+      IF( ln_limdyn    )   CALL lim_sbc_tau_2( kt, ub(:,:,1), vb(:,:,1) )  ! using before instantaneous surf. currents
       !
    END SUBROUTINE sbc_ice_lim_2
